package fr.smallcrew.security.web;

import fr.smallcrew.security.domain.DomainUser;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.User;

import java.util.List;

public class AuthenticatedUser extends User {
  private static final long serialVersionUID = -2156409486711657118L;
  private final DomainUser user;

  public AuthenticatedUser(DomainUser user, List<GrantedAuthority> authorities) {
    super(user.getUsername(), user.getPassword(), authorities);
    this.user = user;
  }

  public String getPasswordSalt() {
    return user.getPasswordSalt();
  }

  public DomainUser getUser() {
    return user;
  }
}
