package fr.smallcrew.security.web;

import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;

import javax.servlet.http.HttpServletRequest;

public class CustomUsernamePasswordAuthenticationFilter extends UsernamePasswordAuthenticationFilter {
  @Override
  protected String obtainPassword(HttpServletRequest request) {
    String password = super.obtainPassword(request);
    if (password == null) {
      password = (String)request.getAttribute(getPasswordParameter());
    }
    return password;
  }

  @Override
  protected String obtainUsername(HttpServletRequest request) {
    String userName = super.obtainUsername(request);
    if (userName == null) {
      userName = (String)request.getAttribute(getUsernameParameter());
    }
    return userName;
  }
}
