package fr.smallcrew.security.web;

import fr.smallcrew.security.domain.DomainUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Controller
@RequestMapping("/login")
public class LoginController {
  @Autowired
  private UsernamePasswordAuthenticationFilter authenticationFilter;

  @RequestMapping(method = RequestMethod.POST)
  public AuthenticatedUserPublic login(HttpServletRequest request, HttpServletResponse response) {
    Authentication authentication = authenticationFilter.attemptAuthentication(request, response);
    authenticationFilter.getRememberMeServices().loginSuccess(request, response, authentication);
    SecurityContextHolder.getContext().setAuthentication(authentication);
    return new AuthenticatedUserPublic(authentication.getName(), authentication.getAuthorities());
  }

  public AuthenticatedUserPublic doLogin(HttpServletRequest request, HttpServletResponse response, String username,
                                         String password) {
    request.setAttribute(DomainUser.USERNAME, username);
    request.setAttribute(DomainUser.PASSWORD, password);
    return login(request, response);
  }
}
